# coding: utf-8

"""
    API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist, constr

class AutoTestStepModel(BaseModel):
    """
    AutoTestStepModel
    """
    title: constr(strict=True, min_length=1) = Field(default=..., description="Step name.")
    description: Optional[StrictStr] = Field(default=None, description="Detailed step description. It appears when the step is unfolded.")
    steps: Optional[conlist(AutoTestStepModel)] = Field(default=None, description="Includes a nested step inside another step. The maximum nesting level is 15.")
    __properties = ["title", "description", "steps"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AutoTestStepModel:
        """Create an instance of AutoTestStepModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in steps (list)
        _items = []
        if self.steps:
            for _item in self.steps:
                if _item:
                    _items.append(_item.to_dict())
            _dict['steps'] = _items
        # set to None if description (nullable) is None
        # and __fields_set__ contains the field
        if self.description is None and "description" in self.__fields_set__:
            _dict['description'] = None

        # set to None if steps (nullable) is None
        # and __fields_set__ contains the field
        if self.steps is None and "steps" in self.__fields_set__:
            _dict['steps'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AutoTestStepModel:
        """Create an instance of AutoTestStepModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AutoTestStepModel.parse_obj(obj)

        _obj = AutoTestStepModel.parse_obj({
            "title": obj.get("title"),
            "description": obj.get("description"),
            "steps": [AutoTestStepModel.from_dict(_item) for _item in obj.get("steps")] if obj.get("steps") is not None else None
        })
        return _obj

AutoTestStepModel.update_forward_refs()

