# coding: utf-8

"""
    API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conint, conlist, constr
from testit_api_client.models.assign_attachment_api_model import AssignAttachmentApiModel
from testit_api_client.models.assign_iteration_api_model import AssignIterationApiModel
from testit_api_client.models.auto_test_id_model import AutoTestIdModel
from testit_api_client.models.tag_model import TagModel
from testit_api_client.models.update_link_api_model import UpdateLinkApiModel
from testit_api_client.models.update_step_api_model import UpdateStepApiModel
from testit_api_client.models.work_item_priority_model import WorkItemPriorityModel
from testit_api_client.models.work_item_source_type_model import WorkItemSourceTypeModel
from testit_api_client.models.work_item_states import WorkItemStates

class UpdateWorkItemApiModel(BaseModel):
    """
    UpdateWorkItemApiModel
    """
    id: StrictStr = Field(default=..., description="Workitem internal identifier")
    section_id: StrictStr = Field(default=..., alias="sectionId", description="Internal identifier of section where workitem is located")
    description: Optional[StrictStr] = Field(default=None, description="Workitem description")
    state: WorkItemStates = Field(...)
    priority: WorkItemPriorityModel = Field(...)
    source_type: Optional[WorkItemSourceTypeModel] = Field(default=None, alias="sourceType")
    steps: conlist(UpdateStepApiModel) = Field(default=..., description="Collection of workitem steps")
    precondition_steps: conlist(UpdateStepApiModel) = Field(default=..., alias="preconditionSteps", description="Collection of workitem precondtion steps")
    postcondition_steps: conlist(UpdateStepApiModel) = Field(default=..., alias="postconditionSteps", description="Collection of workitem postcondition steps")
    duration: conint(strict=True, le=86400000, ge=0) = Field(default=..., description="Workitem duration in milliseconds")
    attributes: Dict[str, Any] = Field(default=..., description="Key value pair of custom workitem attributes")
    tags: conlist(TagModel) = Field(default=..., description="Collection of workitem tags")
    links: conlist(UpdateLinkApiModel) = Field(default=..., description="Collection of workitem links")
    name: constr(strict=True, min_length=1) = Field(default=..., description="Workitem name")
    attachments: conlist(AssignAttachmentApiModel) = Field(...)
    iterations: Optional[conlist(AssignIterationApiModel)] = Field(default=None, description="Collection of parameter id sets")
    auto_tests: Optional[conlist(AutoTestIdModel)] = Field(default=None, alias="autoTests", description="Collection of autotest internal ids")
    __properties = ["id", "sectionId", "description", "state", "priority", "sourceType", "steps", "preconditionSteps", "postconditionSteps", "duration", "attributes", "tags", "links", "name", "attachments", "iterations", "autoTests"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateWorkItemApiModel:
        """Create an instance of UpdateWorkItemApiModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in steps (list)
        _items = []
        if self.steps:
            for _item in self.steps:
                if _item:
                    _items.append(_item.to_dict())
            _dict['steps'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in precondition_steps (list)
        _items = []
        if self.precondition_steps:
            for _item in self.precondition_steps:
                if _item:
                    _items.append(_item.to_dict())
            _dict['preconditionSteps'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in postcondition_steps (list)
        _items = []
        if self.postcondition_steps:
            for _item in self.postcondition_steps:
                if _item:
                    _items.append(_item.to_dict())
            _dict['postconditionSteps'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tags (list)
        _items = []
        if self.tags:
            for _item in self.tags:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tags'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item in self.links:
                if _item:
                    _items.append(_item.to_dict())
            _dict['links'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in attachments (list)
        _items = []
        if self.attachments:
            for _item in self.attachments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['attachments'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in iterations (list)
        _items = []
        if self.iterations:
            for _item in self.iterations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['iterations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in auto_tests (list)
        _items = []
        if self.auto_tests:
            for _item in self.auto_tests:
                if _item:
                    _items.append(_item.to_dict())
            _dict['autoTests'] = _items
        # set to None if description (nullable) is None
        # and __fields_set__ contains the field
        if self.description is None and "description" in self.__fields_set__:
            _dict['description'] = None

        # set to None if source_type (nullable) is None
        # and __fields_set__ contains the field
        if self.source_type is None and "source_type" in self.__fields_set__:
            _dict['sourceType'] = None

        # set to None if iterations (nullable) is None
        # and __fields_set__ contains the field
        if self.iterations is None and "iterations" in self.__fields_set__:
            _dict['iterations'] = None

        # set to None if auto_tests (nullable) is None
        # and __fields_set__ contains the field
        if self.auto_tests is None and "auto_tests" in self.__fields_set__:
            _dict['autoTests'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateWorkItemApiModel:
        """Create an instance of UpdateWorkItemApiModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateWorkItemApiModel.parse_obj(obj)

        _obj = UpdateWorkItemApiModel.parse_obj({
            "id": obj.get("id"),
            "section_id": obj.get("sectionId"),
            "description": obj.get("description"),
            "state": obj.get("state"),
            "priority": obj.get("priority"),
            "source_type": obj.get("sourceType"),
            "steps": [UpdateStepApiModel.from_dict(_item) for _item in obj.get("steps")] if obj.get("steps") is not None else None,
            "precondition_steps": [UpdateStepApiModel.from_dict(_item) for _item in obj.get("preconditionSteps")] if obj.get("preconditionSteps") is not None else None,
            "postcondition_steps": [UpdateStepApiModel.from_dict(_item) for _item in obj.get("postconditionSteps")] if obj.get("postconditionSteps") is not None else None,
            "duration": obj.get("duration"),
            "attributes": obj.get("attributes"),
            "tags": [TagModel.from_dict(_item) for _item in obj.get("tags")] if obj.get("tags") is not None else None,
            "links": [UpdateLinkApiModel.from_dict(_item) for _item in obj.get("links")] if obj.get("links") is not None else None,
            "name": obj.get("name"),
            "attachments": [AssignAttachmentApiModel.from_dict(_item) for _item in obj.get("attachments")] if obj.get("attachments") is not None else None,
            "iterations": [AssignIterationApiModel.from_dict(_item) for _item in obj.get("iterations")] if obj.get("iterations") is not None else None,
            "auto_tests": [AutoTestIdModel.from_dict(_item) for _item in obj.get("autoTests")] if obj.get("autoTests") is not None else None
        })
        return _obj


